/****************************************************************

	USB functions for FT245( SC01&SC02 )

					2015.7.28 M.Utsumi@ARCDEVICE
*****************************************************************/

#include"USB_bt.h"

//WORD USB_wTimeout; 
//volatile WORD USB_wTimeoutCount;

void USB_Open( void )
{
	USB_RD = 1;
	USB_WR = 1;
	TRIS_RD = 0;
	TRIS_WR = 0;

	BUS_SetInput();

//	USB_wTimeout = 0;
//	USB_wTimeoutCount = 0;
}

BOOL USB_Read( BYTE* pBuffer, WORD wSize  )
{
	BUS_SetInput();

	while(wSize--){
//		USB_wTimeoutCount = 0;
		UT_StartTimeoutTimer();
		while(RXF){
//			if( USB_wTimeoutCount > USB_wTimeout  ) return( FALSE );
			if( UT_IsTimeout() ) return( FALSE );
		}
		UT_StopTimeoutTimer();
		USB_RD = 0;
		Nop();
		Nop();
		*pBuffer++ = BUS_Input();
		USB_RD = 1;
	}
	return(TRUE);
}

BOOL USB_Write( BYTE* pBuffer, WORD wSize )
{
	BUS_SetOutput();

	while(wSize--){
//		USB_wTimeoutCount = 0;
		UT_StartTimeoutTimer();
		while(TXE){
//			if( USB_wTimeoutCount > USB_wTimeout  ) return( FALSE );
			if( UT_IsTimeout() ) return( FALSE );
		}
		UT_StopTimeoutTimer();

		USB_WR = 1;
		BUS_Output( *pBuffer++ );
		USB_WR = 0;
	}
	USB_WR = 1;
	return(TRUE);
}
